<template>
  <div style="padding: 50px;">
    <h1 style="margin-left: 10vw;">오류 관리</h1>
    <el-table
      :data="errorList"
      style="width: 80%; left: calc(10%); top: calc(10%)"
      align="center"
      ref="multipleTable"
      @selection-change="handleSelectionChange"
      >
      <el-table-column
        type="selection"
        width="55"
        align="center"
        >
      </el-table-column>
      <el-table-column
        type="index"
        width="50"
        label="#">
      </el-table-column>
      <el-table-column
        prop="name"
        :label="$t('RECORD.NAME')"
        width="180"
        align="center"
        >
      </el-table-column>
      <el-table-column
        prop="email_id"
        :label="$t('RECORD.EMAIL')"
        width="200">
      </el-table-column>
      <el-table-column
        prop="comment"
        :label="$t('RECORD.RECORD_REASON')"
        >
      </el-table-column>
      <el-table-column
        label="-"
        width="150"
        align="center">
        <template slot-scope="scope">
          <el-button type="primary" @click="showVideo(scope.row.video_id)">
            {{ $t('RECORD.SHOW_VIDEO') }}
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        label="-"
        width="150"
        align="center">
        <template slot-scope="scope">
          <el-button type="danger" @click="deleteVideo([scope.row.video_id])">
            {{ $t('RECORD.DELETE_VIDEO') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-button
      type="danger"
      @click="deleteVideo(multipleSelection.map(selection => selection.video_id))"
       style="margin-left: 10%; margin-top: 1%;">
      {{ $t('RECORD.DELETE_SELECTION') }}
    </el-button>
    <el-dialog
      ref="dialog"
      :width="`${dialogWidth}%`"
      :visible.sync="showVideoVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      :before-close="beforeClose"
      :title="$t('RECORD.CHECK_RECORD_VIDEO')"
      >
      <!-- <h3>{{ $t('RECORD.RECORD_VIDEO') }}</h3> -->
      <div v-if="showVideoVisible">
        <video
          ref="video"
          controls>
        </video>
      </div>
      <h3 :style="{ marginTop: '40px' }">{{ $t('RECORD.RECORD_REASON') }}</h3>
      <span> {{ comment }} </span>
      <br>
      <br name="here">
      <el-button type="danger" style="position: relative; width: 120px; left: calc(100% - 250px);" @click="deleteVideo([currentVideoId], closeDialog)">{{ $t('RECORD.DELETE_VIDEO') }}</el-button>
      <el-button style="position: relative; width: 120px; left: calc(100% - 250px);" @click="closeDialog">{{ $t('RECORD.CLOSE_RECORD_VIDEO') }}</el-button>
    </el-dialog>
  </div>
</template>

<script>
import recordService from '../../services/recordService';
import utils from '../../utils';

export default {
  name: 'ErrorManage',
  data() {
    return {
      errorList: [],
      multipleSelection: [],
      showVideoVisible: false,
      recordingVideoSrc: '#',
      comment: '기본 코멘트',
      currentVideoId: null,
      dialogWidth: 60,
    };
  },
  computed: {
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    async showVideo(video_id) {
      const vm = this;
      const loading = this.$loading({
        lock: true,
        text: vm.$t('RECORD.RECEIVING'),
        spinner: 'el-icon-loading'
      });
      let result = null;
      let error = false;
      try {
        result = await recordService.getRecordVideo({
          video_id
        });
      } catch(err) {
        error = true;
        vm.$notify({
            title: '불러오기 오류',
            message: err.toString(),
            type: 'error',
            duration: 5000,
        });
      }
      loading.close();
      if (!error) {
        vm.recordingVideoSrc = `data:video/webm;base64,${result.data.video}`;
        vm.comment = result.data.comment;
        vm.showVideoVisible = true;
        vm.currentVideoId = video_id;
        vm.$nextTick(() => {
          vm.$refs.video.style.width = `${document.body.offsetWidth * (vm.dialogWidth / 100) - 50}px`
          setTimeout(() => {
            vm.$refs.dialog.$el.scrollTop = vm.$refs.dialog.$el.scrollHeight;
            vm.$refs.video.addEventListener('loadedmetadata', event => {
              if (vm.$refs.video.duration === Infinity) {
                // set it to bigger than the actual duration
                vm.$refs.video.currentTime = 1e101;
                vm.$refs.video.ontimeupdate = function() {
                  this.ontimeupdate = () => {
                    return;
                  }
                  vm.$refs.video.currentTime = 0;
                }
              }
            });
            vm.$refs.video.src=vm.recordingVideoSrc;
          }, 100);
        });
      }
    },
    beforeClose(done) {
      const vm = this;
      done();
    },
    closeDialog() {
      const vm = this;
      vm.showVideoVisible = false;
    },
    deleteVideo(video_ids, callback) {
      const vm = this;
      if (video_ids.length > 0) {
        vm.$confirm(vm.$t('RECORD.DELETE_RECORD_MSG', { num: `${video_ids.length}`, s: video_ids.length > 1 ? 's' : '' }), vm.$t('RECORD.DELETE_RECORD'), {
          confirmButtonText: vm.$t('RECORD.CONFIRM'),
          cancelButtonText: vm.$t('RECORD.CANCEL'),
          type: 'warning',
        }).then(async () => {
          const loading = this.$loading({
            lock: true,
            text: vm.$t('RECORD.DELETING'),
            spinner: 'el-icon-loading'
          }); 
          await Promise.all(video_ids.map(video_id => recordService.deleteRecordVideo({ video_id })));
          loading.close();
          callback && callback();
          vm.$notify({
            title: vm.$t('RECORD.DELETE_VIDEO'),
            message: vm.$t('RECORD.DELETED'),
            type: 'success',
            duration: 3000,
          });
          setTimeout(() => {
            vm.updateErrorList();
          }, 100);
        }).catch(() => {
          vm.$notify({
            title: vm.$t('RECORD.DELETE_VIDEO'),
            message: vm.$t('RECORD.CANCELED'),
            type: 'warning',
            duration: 3000,
          });
        });
      }
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    base64toBlob(base64Data, contentType) {
      contentType = contentType || '';
      const sliceSize = 1024;
      const byteCharacters = atob(base64Data);
      const bytesLength = byteCharacters.length;
      const slicesCount = Math.ceil(bytesLength / sliceSize);
      const byteArrays = new Array(slicesCount);

      for (var sliceIndex = 0; sliceIndex < slicesCount; ++sliceIndex) {
        const begin = sliceIndex * sliceSize;
        const end = Math.min(begin + sliceSize, bytesLength);

        const bytes = new Array(end - begin);
        for (let offset = begin, i = 0; offset < end; i += 1, offset += 1) {
          bytes[i] = byteCharacters[offset].charCodeAt(0);
        }
        byteArrays[sliceIndex] = new Uint8Array(bytes);
      }
      return new Blob(byteArrays, { type: contentType });
    },
    async updateErrorList() {
      const vm = this;
      //에러 목록 가져오기
      const result = await recordService.getAllRecordList();
      vm.errorList = result.data.data.map(error => ({
        ...error.user,
        comment: error.comment,
        video_id: error.video_id
      }));
    }
  },
  async mounted() {
    const vm = this;

    //접근 권한 확인
    if (vm.authType !== 3) {
      vm.$notify({
        title: vm.$t('RECORD.NO_AUTH'),
        message: vm.$t('RECORD.NO_AUTH_MSG'),
        type: 'success',
      });
      vm.$router.push({ name: 'LandingPage' });
    }
    setTimeout(() => {
      vm.updateErrorList();
    }, 100);
  },
};
</script>

<style lang="scss" scoped>

</style>